/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#ifndef AVATARSTATS_H
#define AVATARSTATS_H

#include <string>

#include "xml.h"

class	AvatarStats          // everything to do with our player
{
private:
	enum	{ CURRENT, MAXIMUM	};

	std::string	name;
	std::string	rank;
	int	stamina[2];
	int	strength[2];
	int	dexterity[2];
	int	intelligence[2];
	long	cash;
	long	loan;
	int 	hc;
	int	ak;
	int 	merchant_pts;
	int 	trader_pts;

	void	ProcessAKCredits(const AttribList& attrib);
	void	ProcessCash(const AttribList& attrib);
	void	ProcessHaulerCredits(const AttribList& attrib);
	void	ProcessLoan(const AttribList& attrib);
	void	ProcessMerchantCredits(const AttribList& attrib);
	void	ProcessTraderCredits(const AttribList& attrib);

public:
	AvatarStats(const AttribList& attrib);
	~AvatarStats()	{	}

	const std::string&	Name()		{ return(name);	}
	
	void	Clear();
	void	NewStatSelect(const std::string& stat_name);
	void	Process(const AttribList& attrib);
	void	ProcessStats(const AttribList& attrib);
};

#endif

