/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include "infra.h"

#include <sstream>

#include "main.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------


void	Infra::AddEconomy(const AttribList& attrib)
{
	XMLParser::FindAttrib(attrib,"economy",economy);
	workers = XMLParser::FindNumAttrib(attrib,"workers",0);
}

void	Infra::AddFactory(const AttribList& attrib)
{
	std::string	output;
	XMLParser::FindAttrib(attrib,"output",output);
	Factories::iterator	iter = factories.find(output);
	if(iter == factories.end())
		factories[output] = 1;
	else
		iter->second++;
}

void	Infra::Clear()
{
	economy = "None";
	workers = 0;
	factories.clear();
}

void	Infra::Display()
{
	MainForm->MapMemo->Clear();
	std::ostringstream	buffer;
	buffer << system << " system";
	MainForm->MapMemo->Lines->Add(buffer.str().c_str());
	buffer.str("");
	buffer << name << " map";
	MainForm->MapMemo->Lines->Add(buffer.str().c_str());
	buffer.str("");
	buffer << "Owner: " << owner;
	MainForm->MapMemo->Lines->Add(buffer.str().c_str());
	buffer.str("");
	buffer << "Workers: " << workers;
	MainForm->MapMemo->Lines->Add(buffer.str().c_str());
	if(factories.size() > 0)
	{
		MainForm->MapMemo->Lines->Add("Factories:");
		for(Factories::iterator	iter = factories.begin();iter !=  factories.end();iter++)
		{
			buffer.str("");
			buffer << "  " << iter->second << " x " << iter->first;
			MainForm->MapMemo->Lines->Add(buffer.str().c_str());
		}
	}
}

void	Infra::NewInfra(const AttribList& attrib)
{
	Clear();
	XMLParser::FindAttrib(attrib,"system",system);
	XMLParser::FindAttrib(attrib,"name",name);
	XMLParser::FindAttrib(attrib,"owner",owner);
}

void	Infra::RemoveFactory(const AttribList& attrib)
{
	std::string	output;
	XMLParser::FindAttrib(attrib,"output",output);
	Factories::iterator	iter = factories.find(output);
	if(iter != factories.end())
	{
		if(--(iter->second) == 0)
			factories.erase(iter);
	}
}

void	Infra::UpdateWorkers(const AttribList& attrib)
{
	workers = XMLParser::FindNumAttrib(attrib,"workers",0);
}

void	Infra::Write(std::ofstream& file)
{
	file << "<map name='" << name << "' system='" << system << "' owner='" << owner << "'>\n\n";
}

