/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#ifndef INFRA_H
#define INFRA_H

#include <fstream>
#include <map>
#include <string>

#include "xml.h"

typedef std::map<std::string,int,std::less<std::string> >	Factories;

class	Infra
{
private:
	std::string	system;				// The system the map is in
	std::string	name;    	      // The name of the map
	std::string	owner;				// the name of the map's owner
	std::string	economy;				// the planet's economy type
	int		 	workers;				// the number of workers available
	Factories	factories;			// facts indexed by output - int is num of facts on planet

	void	Clear();

public:
	Infra()	{ workers = 0;	}
	~Infra()	{	}

	const std::string&	Name()	{	return(name);	}

	void	AddEconomy(const AttribList& attrib);
	void	AddFactory(const AttribList& attrib);
	void	Display();
	void	NewInfra(const AttribList& attrib);
	void	RemoveFactory(const AttribList& attrib);
	void	UpdateWorkers(const AttribList& attrib);
	void	Write(std::ofstream& file);
};

#endif

