/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#ifndef INITPARSER_H
#define INITPARSER_H

#include "xml.h"

class AccountRec;
class MacroRec;

class InitParser : public XMLParser
{
private:
	static const int	NOT_AN_ELEMENT;
	static const std::string	elements[];

	enum	{ ANY, CMD,	};

	int	status;

	AccountRec	*account;
	MacroRec		*macro_rec;
	int			f_key;

	int	FindElement(const std::string& elem);

	void	Account(const AttribList& attrib);
	void	AudioAlert(const AttribList& attrib);
	void	Avatar(const AttribList& attrib);
	void	BackgroundColour(const AttribList& attrib);
	void	EndAvatar();
	void	EndMacro();
	void	Friend(const AttribList& attrib);
	void	FriendsList(const AttribList& attrib);
	void	InputWindow(const AttribList& attrib);
	void	MacroStart(const AttribList& attrib);
	void	Server(const AttribList& attrib);
	void	SetBuffer(const AttribList& attrib);
	void	SetSoundFX(const AttribList& attrib);
	void	SetTwinkles(const AttribList& attrib);
	void	StartFont(const AttribList& attrib);
	void	StatsPanel(const AttribList& attrib);
	void	Voted(const AttribList& attrib);
	void	WindowSize(const AttribList& attrib);

protected:
	void	StartElement(const std::string& elem,const AttribList& attrib);
	void	EndElement(const std::string& elem);
	void	TextData(const std::string& text);

public:
	InitParser(const std::string& f_name);
	virtual ~InitParser();
};

#endif
