/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include "input.h"

#include <sstream>

#include "fed2.h"
#include "main.h"
#include "tb_code.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------

void	PlayerInput::Process(const char *line,bool clear)
{
	text = line;
	if(clear)
		MainForm->InputEdit->Lines->Clear();
	CleanInput(text);
	MainForm->OutputText(" ");
	std::string temp = "> ";
	temp += text;
	MainForm->OutputText(temp);
	if(std::tolower(text[0]) == 't')
	{
		if(std::tolower(text[1]) == 'b')
			Fed2::tight_beam->ProcessInput(text.substr(3));
		else
		{
			std::string cmd(text.substr(0,4));
			for(int count = 0;count < 4;count++)
				cmd[count] = std::tolower(cmd[count]);
			if(cmd == "tell")
				Fed2::tight_beam->ProcessInput(text.substr(5));
		}
	}
	text += '\n';
	MainForm->Send(text);
}

std::string&	PlayerInput::CleanInput(std::string& line)
{
	while(line[0] == ' ')
		line.erase(0,1);
	int len = line.length();
	for(int count = len - 1;count >= 0;count--)
	{
		if((line[count] == '\r') || (line[count] == '\n'))
			line.erase(count,1);
	}
	return(line);
}

