/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include "logging.h"

#include <cstring>
#include <ctime>

#include "main.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------

Logging::Logging()
{
	std::time_t	now = time(0);
	char	date[48], month[16], day[16], year[16];

	strcpy(date,std::ctime(&now));
	strtok(date," ");
	strcpy(month,strtok(0," "));
	strcpy(day,strtok(0," "));
	strtok(0," ");
	strcpy(year,strtok(0," \n"));
	std::string	file_name = MainForm->HomeDir() + "\\logs\\" + year + month + day + ".log";

	file.open(file_name.c_str(),std::ios::out | std::ios::app);
	if(file)
	{
		std::string	all_ok = file_name + " opened for logging";
		MainForm->OutputText(all_ok);
		MainForm->StatusBar->Panels->Items[1]->Text = "Logging";
		MainForm->StartLoggingItem->Enabled = false;
		MainForm->StopLoggingItem->Enabled = true;
		WriteHeader();
	}
	else
	{
		std::string	error = "***Unable to open " + file_name + " for logging***";
		MainForm->OutputText(error);
	}
}

Logging::Logging(const std::string&	file_name)
{
	file.open(file_name.c_str(),std::ios::out | std::ios::app);
	if(file)
	{
		std::string	all_ok = file_name + " opened for logging";
		MainForm->OutputText(all_ok);
		MainForm->StatusBar->Panels->Items[1]->Text = "Logging";
		WriteHeader();
	}
	else
	{
		std::string	error = "***Unable to open " + file_name + " for logging***";
		MainForm->OutputText(error);
	}
}

Logging::~Logging()
{
	std::time_t	now = std::time(0);
	file << "\n" << std::ctime(&now) << "*** Logging finished ***" << std::endl;
	MainForm->StatusBar->Panels->Items[1]->Text = "";
}

void	Logging::ScreenDump()
{
	MainForm->OpenDialog->Title = "Dump screen buffer to file...";
	std::string	dir = MainForm->HomeDir() + "\\logs";
	MainForm->OpenDialog->InitialDir = dir.c_str();
	if(MainForm->OpenDialog->Execute())
	{
		std::string	file_name(MainForm->OpenDialog->FileName.c_str());
		std::ofstream	file(file_name.c_str(),std::ios::out | std::ios::app);
		if(file)
		{
			std::time_t	now = std::time(0);
			file << "\n*** Screen buffer save ***\n" << std::ctime(&now) << "\n";
			file << MainForm->StoryMemo->Text.c_str();
			file << "\n" << std::ctime(&now) << "*** End of screen buffer save ***\n";
			std::string	msg = "Screen buffer saved to " + file_name;
			MainForm->OutputText(msg);
		}
		else
		{
			std::string	error = "***Unable to open " + file_name + " for screen dump***";
			MainForm->OutputText(error);
		}
	}
}

void	Logging::Write(const std::string& text)
{
	if(file)
		file << text << "\n";
}

void	Logging::WriteHeader()
{
	std::time_t	now = std::time(0);
	file << "\n*** Logging started ***\n" << std::ctime(&now);
}




