/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include "macroform.h"

#include <sstream>

#include "macro.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMacroBox *MacroBox;
//---------------------------------------------------------------------------


const std::string TMacroBox::changed_text = "Text has changed. Do you want to save it?";

__fastcall TMacroBox::TMacroBox(TComponent* Owner)
	: TForm(Owner)
{
	macro = 0;
	current = 0;
}

void __fastcall TMacroBox::FormShow(TObject *Sender)
{
	if(current < 1)
		current = 1;
	macro->Display(current);
}

void __fastcall TMacroBox::CancelBtnClick(TObject *Sender)
{
	Close();
}

void __fastcall TMacroBox::OkBtnClick(TObject *Sender)
{
	if(FKeyMemo->Modified)
	{
		if(MessageDlg(changed_text.c_str(),mtConfirmation,TMsgDlgButtons() << mbYes << mbNo,0) == mrYes)
			macro->Update(current,FKeyMemo);
	}
	Close();
}

void	TMacroBox::UpdateCurrent(int index)
{
	current = index;
	std::ostringstream	buffer;
	buffer << " Text for F" << current << "-Key ";
	FKeyGroup->Caption = buffer.str().c_str();
}


void __fastcall TMacroBox::NextBtnClick(TObject *Sender)
{
	if(FKeyMemo->Modified)
	{
		if(MessageDlg(changed_text.c_str(),mtConfirmation,TMsgDlgButtons() << mbYes << mbNo,0) == mrYes)
			macro->Update(current,FKeyMemo);
	}
	macro->Display(current + 1);
}


void __fastcall TMacroBox::LastBtnClick(TObject *Sender)
{
	if(FKeyMemo->Modified)
	{
		if(MessageDlg(changed_text.c_str(),mtConfirmation,TMsgDlgButtons() << mbYes << mbNo,0) == mrYes)
			macro->Update(current,FKeyMemo);
	}
	macro->Display(current - 1);
}

