/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include "tb_code.h"

#include <sstream>
#include <io.h>

#include "fed2.h"
#include "input.h"
#include "main.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
//-----------------------------------------------------------------------


void	TightBeam::FinishedWithPlayer()
{
	target = "";
	MainForm->TBMemo->Clear();
	MainForm->TBNamePanel->Caption = "Tight beam connection cleared";
	std::string	file_name = ".\\pictures\\interference.bmp";
	if(access(file_name.c_str(),0) == 0)
		MainForm->TBImage->Picture->LoadFromFile(file_name.c_str());
	MainForm->TopNotebook->ActivePage = MainForm->ExSpTab;
}

void	TightBeam::NewPlayer(const std::string& name)
{
	target = name;
	MainForm->TopNotebook->ActivePage = MainForm->PrivateTab;
	std::ostringstream	buffer;
	buffer << name << " - Tight Beam Comms";
	MainForm->TBNamePanel->Caption = buffer.str().c_str();
	MainForm->TBMemo->Clear();

	std::string	temp(name);
	temp[0] = std::tolower(temp[0]);
	std::string	file_name = ".\\pictures\\" + temp + ".bmp";
	if(access(file_name.c_str(),0) != 0)
	{
		file_name = ".\\pictures\\interference.bmp";
		if(access(file_name.c_str(),0) != 0)
			return;
	}
	MainForm->TBImage->Picture->LoadFromFile(file_name.c_str());
	buffer.str("");
	buffer << "Tell " << name << " ";
	MainForm->InputEdit->Clear();
	MainForm->InputEdit->Text = buffer.str().c_str();
	if(MainForm->MainNotebook->ActivePage == MainForm->MainTab)
	{
		MainForm->ActiveControl = MainForm->InputEdit;
		MainForm->InputEdit->SelStart = 999;
	}
}

void	TightBeam::ProcessInput(const std::string& line)
{
	if(target != "")
	{
		std::string::size_type	index = line.find(' ');
		if(index != std::string::npos)
		{
			std::string	name(line.substr(0,index));
			name[0] = std::toupper(name[0]);
			for(int count = 1;static_cast<unsigned>(count) < name.length();count++)
				name[count] =  std::tolower(name[count]);
			if(target == name)
			{
				std::ostringstream	buffer;
				buffer << "You say, \"" << line.substr(index + 1) << ".\"";
				MainForm->TBMemo->Lines->Add(buffer.str().c_str());
			}
		}
	}
}

void	TightBeam::ProcessOutput(const std::string& name,const std::string& text)
{
	std::ostringstream	buffer;
	buffer << "Your comm unit signals a tight beam message from " << name << ", \"" << text << "\"";
	MainForm->OutputText(buffer.str());
	if(name == target)
	{
		buffer.str("");
		buffer << name << " says, \"" << text << "\"";
		MainForm->TBMemo->Lines->Add(buffer.str().c_str());
	}
}



