/*-----------------------------------------------------------------------
				FedTerm version 1.60 - Windows Federation 2 Client
			  Copyright (c) 1995-2006 Interactive Broadcasting Ltd

	This program is free software: you can redistribute it and /or modify 
	it under the terms of the GNU General Public License as published by 
	the Free Software Foundation: either version 2 of the License, or (at 
	your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY: without even the implied warranty of 
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
	General Public License for more details.

	You should have received a copy of the GNU General Public License 
	along with this program; if not, write to the Free Software Foundation, 
	Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307 USA

	Program written and compiled with Borland C++ Builder 5
	Programming and design: 	Alan Lenton
	Home website:					www.ibgames.net
-----------------------------------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include "tmc_code.h"

#include <shellapi.h>

#include "fed2.h"
#include "init.h"
#include "main.h"
#include "tmc.h"
#include "tmc_reminder.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------

const long	Tmc::ONE_DAY = 60 * 60 *24;
// const long	Tmc::ONE_DAY = 60;  // for test purposes only :)


void	Tmc::AlreadyVoted()
{
	Fed2::init->Voted(std::time(0));
}

void	Tmc::Cancel()
{
	Fed2::init->Voted(0);
}

void	Tmc::CheckTime()
{
	std::time_t	last = Fed2::init->Voted();
	std::time_t	now =  std::time(0);
	if(last == 0)
		return;
	else
	{
		if(now - last > ONE_DAY)
		{
			Application->CreateForm(__classid(TTmcReminderForm), &TmcReminderForm);
			TmcReminderForm->Visible = true;
		}
	}
}

void	Tmc::MenuClick()
{
	std::time_t	last = Fed2::init->Voted();
	std::time_t	now =  std::time(0);
	Application->CreateForm(__classid(TTmcForm), &TmcForm);
	TmcForm->Visible = true;
}

void	Tmc::VoteNow()
{
	std::time_t	last = Fed2::init->Voted();
	std::time_t	now =  std::time(0);
	if(now - last > ONE_DAY)
	{
		ShellExecute(MainForm->Handle,0,"http://www.ibgames.net/fed2/vote.html",0,0,SW_NORMAL);
		Fed2::init->Voted(now);
	}
	else
		MessageDlg("You've already voted\nin the last 24 hours!",mtError,TMsgDlgButtons() << mbOK,0);
}


