/*-----------------------------------------------------------------------
			Copyright (c) Interactive Broadcasting 2005
	All Rights Reserved. No part of this software may be reproduced,
	transmitted, transcribed, stored in a retrieval system, or translated
	into any human or computer language, in any form or by any means,
	electronic, mechanical, magnetic, optical, manual or otherwise,
	without the express written permission of the copyright holder.
-----------------------------------------------------------------------*/

#ifndef TOKENS_H
#define TOKENS_H

#include <string>
#include <utility>
#include <vector>

typedef	std::pair<int,std::string>	TokenRec;
typedef	std::vector<TokenRec>TokenArray;

class	Tokens
{
private:
	TokenArray	token_array;

public:
	Tokens(int max_size = 10)		{ token_array.resize(max_size);	}
	~Tokens()							{	}
	const std::string&	operator[](int index) const;

	int	Start(int index);			// return index of string start for the specified token
	int	Size() const 				{ return(token_array.size());	}

	void	Tokenize(const std::string& line,char sep = ' ',int max_tokens = 10);
};

#endif
