/*-----------------------------------------------------------------------
			Copyright (c) Interactive Broadcasting 2005
	All Rights Reserved. No part of this software may be reproduced,
	transmitted, transcribed, stored in a retrieval system, or translated
	into any human or computer language, in any form or by any means,
	electronic, mechanical, magnetic, optical, manual or otherwise,
	without the express written permission of the copyright holder.
-----------------------------------------------------------------------*/

#ifndef XMLPARSER_H
#define XMLPARSER_H

#include <fstream>
#include <list>
#include <string>

struct AttribRec
{
	std::string	name;
	std::string	value;
};

typedef std::list<AttribRec> AttribList;

class	XMLParser	// WARNING: Not a full parser...
{
private:
	std::string		file_name;
	std::ifstream	file;

	std::string		element;
	AttribList		attrib_list;

protected:
	void	BuildAttributes(const std::string& line);
	void	BuildElement(const std::string& line);
	void	ProcessLine(const std::string& line);

	virtual void	EndElement(const std::string& elem)	{	}
	virtual void	StartElement(const std::string& elem,const AttribList& attrib)	{	}
	virtual void	TextData(const std::string& text)	{	}

	virtual void	WriteError(const std::string& text)	{	}

public:
	static std::string&	EscapeXML(std::string& text);
	static std::string&	UnEscapeXML(std::string& text);

	static std::string	FindAttrib(const AttribList& attrib,const std::string& name,std::string& value);
	static bool				FindBoolAttrib(const AttribList& attrib,const std::string& name,bool default_val);
	static int 				FindNumAttrib(const AttribList& attrib,const std::string& name,int default_val);

	XMLParser(const std::string& f_name);
	virtual	~XMLParser();

	bool	Parse();
	void	Parse(const std::string& line);
};

#endif

